#ifndef EFL_UI_SELECTABLE_EO_HH
#define EFL_UI_SELECTABLE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_ui_selectable.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace ui { 
struct Selectable;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Selectable> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { namespace ui { 
struct Selectable {
   static Eo_Class const* _eo_class()
   {
      return EFL_UI_SELECTABLE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::ui::Selectable() const;
   operator ::efl::ui::Selectable&();
   operator ::efl::ui::Selectable const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Selectable> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Selectable const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace ui { 
struct Selectable : ::efl::eo::concrete
{
   explicit Selectable( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Selectable(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Selectable(Selectable const& other) = default;
   Selectable(Selectable&& other) = default;
   Selectable& operator=(Selectable const& other) = default;
   Selectable& operator=(Selectable&& other) = default;
   Selectable()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Selectable( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Selectable(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   static Eo_Class const* _eo_class()
   {
      return EFL_UI_SELECTABLE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct selected_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_SELECTED; }
      typedef void parameter_type;
   } const selected_event;
   static struct unselected_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_UNSELECTED; }
      typedef void parameter_type;
   } const unselected_event;
   static struct selection_paste_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_SELECTION_PASTE; }
      typedef void parameter_type;
   } const selection_paste_event;
   static struct selection_copy_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_SELECTION_COPY; }
      typedef void parameter_type;
   } const selection_copy_event;
   static struct selection_cut_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_SELECTION_CUT; }
      typedef void parameter_type;
   } const selection_cut_event;
   static struct selection_start_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_SELECTION_START; }
      typedef void parameter_type;
   } const selection_start_event;
   static struct selection_changed_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_SELECTION_CHANGED; }
      typedef void parameter_type;
   } const selection_changed_event;
   static struct selection_cleared_event
   {
      static Eo_Event_Description const* description()
      { return EFL_UI_EVENT_SELECTION_CLEARED; }
      typedef void parameter_type;
   } const selection_cleared_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Selectable> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Selectable const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Selectable) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Selectable>::value, "");
} } 
#include "efl_ui_selectable.eo.impl.hh"
#endif
